/* C++ header file: Objectivity/DB DDL version 6.1.0         */

#ifndef STRINGCONTAINER_H_
#define STRINGCONTAINER_H_
#include <vector>
#include <list>
#include <string>
namespace pool_tests {

  struct StringContainer {
    std::string               m_string;
    std::list<std::string>    m_stringList;
    std::vector<std::string>  m_stringVec;
    StringContainer();
    virtual ~StringContainer();
    void set(int i);
    void dump() const;
  };
}
#endif /* !defined(STRINGCONTAINER_H_) */
