// Root patch
#ifdef _WIN32
  #define R__GLOBALSTL
  #ifndef ROOT_w32pragma
    #include "w32pragma.h"
  #endif
  #include "Rtypeinfo.h"
  #undef R__GLOBALSTL
  #include "TNamed.h"
#endif
#include "pool/test.h"
#include "pool/test_bool.h"
#include "pool/PerformanceObj.h"

class AAAA {
public:
  std::string m_str;
public:
  AAAA() {}
  const std::string& getStr() { return m_str; }
};


namespace {
  class dummy {
  public:
    std::list<bool>                                        s_list_bool;
    std::list<char>                                        s_list_char;
    std::list<int>                                         s_list_int;
    std::list<std::vector<char> >                          s_list_vec_char;
    std::list<std::vector<int> >                           s_list_vec_int;
    std::vector<char>                                      s_vector_char;
    std::vector<short>                                     s_vector_short;
    std::vector<int>                                       s_vector_int;
    std::vector<float>                                     s_vector_float;
    std::vector<double>                                    s_vector_double;
    std::vector<NoVirtual>                                 s_vector_NoVirtual;
    std::vector<std::pair<float, float> >                  s_vector_pair_float_float;
    std::pair<float, float>                                s_pair_float_float;
    DumbStruct<int>                                        s_dum_int;
    const Aggregated                                       s_const_agg;
    std::vector<std::pair<int,int> >                       s_vec_pair_int_int;
    std::vector<std::pair<unsigned long,unsigned long> >   s5;
    std::pair<std::string, std::string>                    s6;
    std::list<std::pair<int,int> >                         s_list_pair_int_int;
    std::list<std::pair<unsigned long,unsigned long> >     s_list_pair_ulong_ulong;
    std::list<std::pair<const int,float> >                 s_list_pair_cint_float;
    std::list<std::pair<const std::string, std::string> >  s_list_pair_cstring_string;
    STDEXT::hash_map<std::string, std::string>             s_hash_map_string_string;
    STDEXT::hash_set<unsigned short int>                   s_hash_set_ushortint;
    std::multiset<short unsigned int>                      s_multiset_ushort;
    std::multimap<std::string, std::string>                s_multimap_string_string;
    Aggregated                                             s_aggr_array[5];
    int                                                    s_int_array[5];
    std::pair<std::string, std::string >                   s_pair_string_string;
    std::pair<std::string, pool::Ref<TNamed> >             s_pair_string_pool_ref_named;
    std::pair<std::string, std::vector<std::string> >      s_pair_string_string_vector;
    std::map<std::string, pool::Ref<TNamed> >              s_map_string_pool_ref_named;
    std::map<std::string, std::vector<std::string> >       s_map_string_string_vector;
    std::multimap<std::string, pool::Ref<TNamed> >         s_multimap_string_pool_ref_named;
    std::list<std::pair<const std::string, pool::Ref<TNamed> > >       s_list_cstring_pool_ref_named;
    std::list<std::pair<const std::string, pool::Ref<TNamed> > >::iterator       s_list_cstring_pool_ref_named_iter;
    STDEXT::hash_map<std::string, pool::Ref<TNamed> >      s_hash_map_string_pool_ref_named;
    STDEXT::hash_multimap<std::string, pool::Ref<TNamed> > s_hash_multimap_string_pool_ref_named;
    DumbStruct<std::vector<std::pair<float,float> > >      s_du_vec_float_float;
    DumbStruct<std::vector<std::vector<char> > >           s_du_vec_vec_char;
    DumbStruct<std::vector<NoVirtual> >                    s_du_vec_no_virtual;
    DumbStruct<std::vector<Aggregated*> >                  s_du_vec_aggP;

    pool::own_ptr<Aggregated>                              s_own_ptr_aggregated;

    std::vector<const Aggregated*>                         s_vec_aggrstar;
    std::vector<std::vector<char> >                        s_vec_vec_char;
    std::vector<std::vector<int> >                         s_vec_vec_int;
    std::vector<NoVirtual>                                 s_vec_NoVirtual;

    dummy() : s_const_agg() {}
  };
}
