#include "POOLCore/Exception.h"

void printM(std::string str){
  std::cout << str << std::endl;
}

void printE(pool::Exception e){
  std::cout << "Exception: "<<e.what()<<std::endl; 
}

class TestKernel {
  private:
   unsigned int nerr;
 public:
  
   TestKernel():nerr(0){}

   void printError(std::string str){
     printM(str);
     nerr++;
   }

   void dumpError() const {
     std::cout << "[OVAL] Test result: " << nerr << " Errors"<<std::endl;
   }

   unsigned int errors() const {
     return nerr;
   }

   void addError() {
     nerr++;
   }

   void resetError(){
     nerr = 0;
   }
};
