#include "POOLCore/Context.h"
#include "POOLCore/IBlobStreamingService.h"
#include "RelationalAccess/IConnectionService.h"
// to be removed!!!
#include "RelationalAccess/ConnectionService.h"

pool::Context::Context():m_blobStreamingService(0),m_blobStreamingServiceOwnership(false),
                                 m_connectionService(0),m_connectionServiceOwnership(false){
}

pool::Context::~Context(){
  if(m_blobStreamingService && m_blobStreamingServiceOwnership){
    delete m_blobStreamingService;
  }  
  if(m_connectionService && m_connectionServiceOwnership){
    // to be fixed!
    delete dynamic_cast<const coral::ConnectionService*>(m_connectionService);
    //delete m_connectionService;
  }  
}

void
pool::Context::setBlobStreamer(pool::IBlobStreamingService* service, bool giveUpOwnership){
  if(m_blobStreamingService && m_blobStreamingServiceOwnership){
    delete m_blobStreamingService;
  }
  m_blobStreamingService = service;
  m_blobStreamingServiceOwnership = giveUpOwnership;
}

void 
pool::Context::setConnectionService(coral::IConnectionService* service, bool giveUpOwnership){
  if(m_connectionService && m_connectionServiceOwnership){
    // to be fixed!
    delete dynamic_cast<const coral::ConnectionService*>(m_connectionService);
    //delete m_connectionService;
  }
  m_connectionService = service;
  m_connectionServiceOwnership = giveUpOwnership;
  m_connectionService = service;
}

