# include "test.h"

bool basic_spec();
bool spec_list_order_ignored();
bool spec_list_not_equal();
bool spec_list_includes();
bool basic_attr_list();
bool spec_append_merge();

int main()
{
  try
    {
      RUN_TEST(basic_spec());
      RUN_TEST(spec_list_order_ignored());
      RUN_TEST(spec_list_not_equal());
      RUN_TEST(spec_list_includes());
      RUN_TEST(basic_attr_list());
      RUN_TEST(spec_append_merge());
    }
  catch(const std::exception&x)
    {
      cerr << "exception occured" << endl;
      cerr << x.what() << endl;
      return -1;
    }
  catch(...)
    {
      cerr << "some exception occured but no further information present" << endl;
      return -1;
    }
  return 0;
}
