#include "DataSvc/IDataSvcFactory.h"
#include "DataSvc.h"

// This class signature has been kept only for backward compatibility.
pool::IDataSvcFactory::IDataSvcFactory(){}

pool::IDataSvc* pool::IDataSvcFactory::create(const std::string& className,const DataSvcContext& ctx)
{
  IDataSvc* ret = 0;
  if(className=="DataSvc") ret = new DataSvc(ctx);
  return ret;
}

pool::IDataSvcFactory*
pool::IDataSvcFactory::get()
{
  static pool::IDataSvcFactory s_instance;
  return &s_instance;
}

