#ifndef IDATATRANSFORMFACTORY_H
#define IDATATRANSFORMFACTORY_H

#include "PersistencySvc/IDataTransform.h"
#include <iostream>

namespace pool {

  // This class signature has been kept only for backward compatibility.
  class IDataTransformFactory
  {
  public:
    static IDataTransformFactory* get();

    IDataTransform* create(const std::string& className);
    
  private:
    IDataTransformFactory();
  };

}

#endif
