#ifndef ITOKENVALIDATORFACTORY_H
#define ITOKENVALIDATORFACTORY_H

#include "PersistencySvc/ITokenValidator.h"
#include <string>

namespace pool {

  // This class signature has been kept only for backward compatibility.
  class ITokenValidatorFactory 
  {
  public:
    static ITokenValidatorFactory* get();
    ITokenValidator* create(const std::string& className);
    
  private:
    ITokenValidatorFactory();
  };

}

#endif
